#include <jni.h>
#include "Dislin.h"
#include "dislin.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

static char *clegbf;
static int ilegop = 0;

static JNIEnv *envcbk;
static jobject *objcbk;
static jmethodID midcbk;

float funcbck (float x, float y, int iopt);
float funcbck2 (float x, float y);

JNIEXPORT void JNICALL 
Java_Dislin_abs3pt (JNIEnv *env, jobject object, jfloat x, jfloat y,
                    jfloat z, jfloatArray arr1)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  abs3pt (x, y, z, &xray[0], &xray[1]);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_angle (JNIEnv *env, jobject object, jint i)
{
  angle (i);
}

JNIEXPORT void JNICALL 
Java_Dislin_arcell (JNIEnv *env, jobject object, jint nx, jint ny,
                    jint na, jint nb, jfloat a, jfloat b, jfloat t)
{
  arcell (nx, ny, na, nb, a, b, t);
}

JNIEXPORT void JNICALL 
Java_Dislin_areaf (JNIEnv *env, jobject object, jintArray arr1, jintArray arr2,
                   jint n)
{
  jint *nxray = (*env)->GetIntArrayElements(env, arr1, 0);
  jint *nyray = (*env)->GetIntArrayElements(env, arr2, 0);
  areaf ((int *) nxray, (int *) nyray, n);
  (*env)->ReleaseIntArrayElements(env, arr1, nxray, 0);
  (*env)->ReleaseIntArrayElements(env, arr2, nyray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_autres (JNIEnv *env, jobject object, jint i, jint j)
{
  autres (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_ax2grf (JNIEnv *env, jobject object)
{
  ax2grf ();
}

JNIEXPORT void JNICALL 
Java_Dislin_ax3len (JNIEnv *env, jobject object, jint i, jint j, jint k)
{
  ax3len (i, j, k);
}

JNIEXPORT void JNICALL
Java_Dislin_axclrs (JNIEnv *env, jobject object, jint i, jstring s1, 
                    jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  axclrs (i, (char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_axends (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  axends ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_axgit (JNIEnv *env, jobject object)
{
  axgit ();
}

JNIEXPORT void JNICALL
Java_Dislin_axis3d (JNIEnv *env, jobject object, jfloat x, jfloat y, jfloat z)
{ axis3d (x, y, z);
}

JNIEXPORT void JNICALL 
Java_Dislin_axslen (JNIEnv *env, jobject object, jint i, jint j)
{
  axslen (i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_axsorg (JNIEnv *env, jobject object, jint i, jint j)
{
  axsorg (i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_axspos (JNIEnv *env, jobject object, jint i, jint j)
{
  axspos (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_axsscl (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  axsscl ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_axstyp (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  axstyp ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_bargrp (JNIEnv *env, jobject object, jint i, jfloat x)
{
  bargrp (i, x);
}

JNIEXPORT void JNICALL
Java_Dislin_barpos (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  barpos ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_bars (JNIEnv *env, jobject object, 
        jfloatArray arr1, jfloatArray arr2, jfloatArray arr3, jint n)
{
  jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *y1ray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *y2ray = (*env)->GetFloatArrayElements(env, arr3, 0);
  bars ((float *) xray, (float *) y1ray, (float *) y2ray, n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, y1ray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, y2ray, 0);
}

JNIEXPORT void JNICALL
Java_Dislin_bartyp (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  bartyp ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_barwth (JNIEnv *env, jobject object, jfloat x)
{ barwth (x);
}

JNIEXPORT void JNICALL
Java_Dislin_basalf (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  basalf ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_bezier (JNIEnv *env, jobject object, 
        jfloatArray arr1, jfloatArray arr2, jint nray, 
        jfloatArray arr3, jfloatArray arr4, jint n)
{
  jfloat *xray  = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray  = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *x2ray = (*env)->GetFloatArrayElements(env, arr3, 0);
  jfloat *y2ray = (*env)->GetFloatArrayElements(env, arr4, 0);

  bezier ((float *) xray, (float *) yray, nray,
          (float *) x2ray, (float *) y2ray, n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, x2ray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr4, y2ray, 0);
}

JNIEXPORT jshort JNICALL 
Java_Dislin_bitsi2 (JNIEnv *env, jobject object, jint nbits, jshort mher,
                    jint iher, short mhin, jint ihin)
{
  return  bitsi2 (nbits, mher, iher, mhin, ihin);
}

JNIEXPORT jint JNICALL 
Java_Dislin_bitsi4 (JNIEnv *env, jobject object, jint nbits, jint mher,
                    jint iher, jint mhin, jint ihin)
{
  return  bitsi4 (nbits, mher, iher, mhin, ihin);
}

JNIEXPORT void JNICALL
Java_Dislin_box2d (JNIEnv *env, jobject object)
{
  box2d ();
}

JNIEXPORT void JNICALL
Java_Dislin_box3d (JNIEnv *env, jobject object)
{
  box3d ();
}

JNIEXPORT void JNICALL
Java_Dislin_center (JNIEnv *env, jobject object)
{
  center ();
}

JNIEXPORT void JNICALL
Java_Dislin_chaang (JNIEnv *env, jobject object, jfloat x)
{ chaang (x);
}

JNIEXPORT void JNICALL
Java_Dislin_chaspc (JNIEnv *env, jobject object, jfloat x)
{ chaspc (x);
}

JNIEXPORT void JNICALL
Java_Dislin_chawth (JNIEnv *env, jobject object, jfloat x)
{ chawth (x);
}

JNIEXPORT void JNICALL
Java_Dislin_chnatt (JNIEnv *env, jobject object)
{
  chnatt ();
}

JNIEXPORT void JNICALL
Java_Dislin_chncrv (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  chncrv ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_chndot (JNIEnv *env, jobject object)
{
  chndot ();
}

JNIEXPORT void JNICALL
Java_Dislin_chndsh (JNIEnv *env, jobject object)
{
  chndsh ();
}

JNIEXPORT void JNICALL
Java_Dislin_chnpie (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  chnpie ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_circle (JNIEnv *env, jobject object, jint i, jint j, jint k)
{
  circle (i, j, k);
}

JNIEXPORT void JNICALL 
Java_Dislin_circsp (JNIEnv *env, jobject object, jint i)
{
  circsp (i);
}

JNIEXPORT void JNICALL
Java_Dislin_clip3d (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  clip3d ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT jint JNICALL
Java_Dislin_closfl (JNIEnv *env, jobject object, jint i)
{ return closfl (i);
}
 
JNIEXPORT void JNICALL
Java_Dislin_clpbor (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  clpbor ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_clpmod (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  clpmod ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_clpwin (JNIEnv *env, jobject object, jint nx, jint ny, 
                                                 jint nw, jint nh)
{
  clpwin (nx, ny, nw, nh);
}

JNIEXPORT void JNICALL 
Java_Dislin_clrcyc (JNIEnv *env, jobject object, jint i, jint j)
{
  clrcyc (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_clrmod (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  clrmod ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_clswin (JNIEnv *env, jobject object, jint i)
{
  clswin (i);
}

JNIEXPORT void JNICALL
Java_Dislin_color (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  color ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_colran (JNIEnv *env, jobject object, jint i, jint j)
{
  colran (i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_colray (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jintArray arr2, jint n)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jint *nray = (*env)->GetIntArrayElements(env, arr2, 0);
  colray ((float *) xray, (int *) nray, n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseIntArrayElements(env, arr2, nray, 0);
}

JNIEXPORT void JNICALL
Java_Dislin_complx (JNIEnv *env, jobject object)
{
  complx ();
}

JNIEXPORT void JNICALL 
Java_Dislin_concrv (JNIEnv *env, jobject object, 
            jfloatArray arr1, jfloatArray arr2, jint n, jfloat zlev)
{
  jsize n1 = (*env)->GetArrayLength(env, arr1);
  jsize n2 = (*env)->GetArrayLength(env, arr2);

  jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  concrv ((float *) xray, (float *) yray, n, zlev);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
}

JNIEXPORT void JNICALL
Java_Dislin_congap (JNIEnv *env, jobject object, jfloat x)
{ congap (x);
}

JNIEXPORT void JNICALL
Java_Dislin_conlab (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  conlab ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_conmat (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jint nx, jint ny, jfloat zlev)
{
  jfloat *zmat = (*env)->GetFloatArrayElements(env, arr1, 0);
  conmat ((float *) zmat, nx, ny, zlev);
  (*env)->ReleaseFloatArrayElements(env, arr1, zmat, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_conmod (JNIEnv *env, jobject object, jfloat x, jfloat y)
{
  conmod (x, y);
}

JNIEXPORT void JNICALL 
Java_Dislin_conn3d (JNIEnv *env, jobject object, jfloat x, jfloat y, jfloat z)
{
  conn3d (x, y, z);
}

JNIEXPORT void JNICALL 
Java_Dislin_connpt (JNIEnv *env, jobject object, jfloat x, jfloat y)
{
  connpt (x, y);
}

JNIEXPORT jint JNICALL 
Java_Dislin_conpts (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jint n, jfloatArray arr2, jint m,
                   jfloatArray arr3, jfloat zlev, jfloatArray arr4,
                   jfloatArray arr5, jint maxpts, jintArray arr6, jint maxray)
{ int ncurvs;
  jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *zmat = (*env)->GetFloatArrayElements(env, arr3, 0);
  jfloat *xpts = (*env)->GetFloatArrayElements(env, arr4, 0);
  jfloat *ypts = (*env)->GetFloatArrayElements(env, arr5, 0);
  jint *nray = (*env)->GetIntArrayElements(env, arr6, 0);
  conpts ((float *) xray, n, (float *) yray, m, (float *) zmat, zlev,
          (float *) xpts, (float *) ypts, maxpts, (int *) nray, maxray, 
          &ncurvs);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, zmat, 0);
  (*env)->ReleaseFloatArrayElements(env, arr4, xpts, 0);
  (*env)->ReleaseFloatArrayElements(env, arr5, ypts, 0);
  (*env)->ReleaseIntArrayElements(env,   arr6, nray, 0);
  return ncurvs;
}

JNIEXPORT void JNICALL 
Java_Dislin_conshd (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jint n, jfloatArray arr2, jint m,
                   jfloatArray arr3, jfloatArray arr4, jint nlev)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *zmat = (*env)->GetFloatArrayElements(env, arr3, 0);
  jfloat *zlev = (*env)->GetFloatArrayElements(env, arr4, 0);
  conshd ((float *) xray, n, (float *) yray, m, (float *) zmat, 
          (float *) zlev, nlev);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, zmat, 0);
  (*env)->ReleaseFloatArrayElements(env, arr4, zlev, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_contur (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jint n, jfloatArray arr2, jint m,
                   jfloatArray arr3, jfloat zlev)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *zmat = (*env)->GetFloatArrayElements(env, arr3, 0);
  contur ((float *) xray, n, (float *) yray, m, (float *) zmat, zlev);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, zmat, 0);
}

JNIEXPORT void JNICALL
Java_Dislin_cross (JNIEnv *env, jobject object)
{
  cross ();
}

JNIEXPORT void JNICALL 
Java_Dislin_crvmat (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jint nx, jint ny, jint ipts, jint jpts)
{
  jfloat *zmat = (*env)->GetFloatArrayElements(env, arr1, 0);
  crvmat ((float *) zmat, nx, ny, ipts, jpts);
  (*env)->ReleaseFloatArrayElements(env, arr1, zmat, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_curve (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jfloatArray arr2, jint n)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  curve ((float *) xray, (float *) yray, n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_curv3d (JNIEnv *env, jobject object, 
        jfloatArray arr1, jfloatArray arr2, jfloatArray arr3, jint n)
{
  jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *zray = (*env)->GetFloatArrayElements(env, arr3, 0);
  curv3d ((float *) xray, (float *) yray, (float *) zray, n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, zray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_curve3 (JNIEnv *env, jobject object, 
        jfloatArray arr1, jfloatArray arr2, jfloatArray arr3, jint n)
{
  jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *zray = (*env)->GetFloatArrayElements(env, arr3, 0);
  curve3 ((float *) xray, (float *) yray, (float *) zray, n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, zray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_curvmp (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jfloatArray arr2, jint n)
{
  jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  curvmp ((float *) xray, (float *) yray, n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_curvx3 (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jfloat y, jfloatArray arr2, jint n)
{
  jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  curvx3 ((float *) xray, y, (float *) yray, n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_curvy3 (JNIEnv *env, jobject object, jfloat x, 
                   jfloatArray arr1, jfloatArray arr2, jint n)
{
  jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  curvy3 (x, (float *) xray, (float *) yray, n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
}

JNIEXPORT void JNICALL
Java_Dislin_dash (JNIEnv *env, jobject object)
{
  dash ();
}

JNIEXPORT void JNICALL
Java_Dislin_dashl (JNIEnv *env, jobject object)
{
  dashl ();
}

JNIEXPORT void JNICALL
Java_Dislin_dashm (JNIEnv *env, jobject object)
{
  dashm ();
}

JNIEXPORT void JNICALL
Java_Dislin_digits (JNIEnv *env, jobject object, jint i, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  digits (i, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_disalf (JNIEnv *env, jobject object)
{
  disalf ();
}

JNIEXPORT void JNICALL
Java_Dislin_disfin (JNIEnv *env, jobject object)
{
  disfin ();
}

JNIEXPORT void JNICALL
Java_Dislin_disini (JNIEnv *env, jobject object)
{
  lsechk ("off");
  disini ();
}

JNIEXPORT void JNICALL
Java_Dislin_dot (JNIEnv *env, jobject object)
{
  dot ();
}

JNIEXPORT void JNICALL
Java_Dislin_dotl (JNIEnv *env, jobject object)
{
  dotl ();
}

JNIEXPORT void JNICALL
Java_Dislin_duplx (JNIEnv *env, jobject object)
{
  duplx ();
}

JNIEXPORT jint JNICALL
Java_Dislin_dwgbut (JNIEnv *env, jobject object, jstring s, jint ival)
{ int iret;
  const char *str = (*env)->GetStringUTFChars(env, s, 0);
  iret = dwgbut ((char *) str, ival);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return iret;
}

JNIEXPORT jstring JNICALL
Java_Dislin_dwgfil (JNIEnv *env, jobject object, jstring s1, jstring s2, 
                    jstring s3)
{ char *p;
  const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  const char *str3 = (*env)->GetStringUTFChars(env, s3, 0);
  p = dwgfil ((char *) str1, (char *) str2, (char *) str3);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
  (*env)->ReleaseStringUTFChars(env, s3, str3);
  return (*env)->NewStringUTF(env, p);
}

JNIEXPORT jint JNICALL
Java_Dislin_dwglis (JNIEnv *env, jobject object, jstring s1, jstring s2, 
                    jint ilis)
{ int iret;
  const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  iret = dwglis ((char *) str1, (char *) str2, ilis);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
  return iret;
}

JNIEXPORT void JNICALL
Java_Dislin_dwgmsg (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  dwgmsg ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT jstring JNICALL
Java_Dislin_dwgtxt (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ char *p;
  const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  p = dwgtxt ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
  return (*env)->NewStringUTF(env, p);
}

JNIEXPORT void JNICALL 
Java_Dislin_ellips (JNIEnv *env, jobject object, jint nx, jint ny, 
                                                 jint nw, jint nh)
{
  ellips (nx, ny, nw, nh);
}

JNIEXPORT void JNICALL
Java_Dislin_endgrf (JNIEnv *env, jobject object)
{
  endgrf ();
}

JNIEXPORT void JNICALL
Java_Dislin_erase (JNIEnv *env, jobject object)
{
  erase ();
}

JNIEXPORT void JNICALL 
Java_Dislin_errbar (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jfloatArray arr2, 
                   jfloatArray arr3, jfloatArray arr4, jint n)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *err1 = (*env)->GetFloatArrayElements(env, arr3, 0);
  jfloat *err2 = (*env)->GetFloatArrayElements(env, arr4, 0);
  errbar ((float *) xray, (float *) yray, (float *) err1, (float *) err2, n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, err1, 0);
  (*env)->ReleaseFloatArrayElements(env, arr4, err2, 0);
}

JNIEXPORT void JNICALL
Java_Dislin_errfil (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  errfil ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_errdev (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  errdev ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_eushft (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  eushft ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_expzlb (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  expzlb ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT jstring JNICALL
Java_Dislin_fcha (JNIEnv *env, jobject object, jfloat x, jint ndig)
{ char cstr[80];
  int nl;
  nl = fcha (x, ndig, cstr);
  return (*env)->NewStringUTF(env, cstr);
}

JNIEXPORT void JNICALL 
Java_Dislin_field (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jfloatArray arr2, 
                   jfloatArray arr3, jfloatArray arr4, jint n, jint ivec)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *uray = (*env)->GetFloatArrayElements(env, arr3, 0);
  jfloat *vray = (*env)->GetFloatArrayElements(env, arr4, 0);
  field ((float *) xray, (float *) yray, (float *) uray, (float *) vray, n,
         ivec);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, uray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr4, vray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_filbox (JNIEnv *env, jobject object, jint nx, jint ny, 
                                                 jint nw, jint nh)
{
  filbox (nx, ny, nw, nh);
}

JNIEXPORT void JNICALL
Java_Dislin_filclr (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  filclr ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_filmod (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  filmod ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_fixspc (JNIEnv *env, jobject object, jfloat x)
{ fixspc (x);
}

JNIEXPORT void JNICALL
Java_Dislin_flab3d (JNIEnv *env, jobject object)
{
  flab3d ();
}

JNIEXPORT jint JNICALL
Java_Dislin_flen (JNIEnv *env, jobject object, jfloat x, jint i)
{ return flen (x, i);
}

JNIEXPORT void JNICALL 
Java_Dislin_frame (JNIEnv *env, jobject object, jint i)
{
  frame (i);
}

JNIEXPORT void JNICALL 
Java_Dislin_frmess (JNIEnv *env, jobject object, jint i)
{
  frmess (i);
}

JNIEXPORT void JNICALL
Java_Dislin_gapcrv (JNIEnv *env, jobject object, jfloat x)
{ gapcrv (x);
}

JNIEXPORT jint JNICALL
Java_Dislin_getang (JNIEnv *env, jobject object)
{ return getang ();
}

JNIEXPORT jint JNICALL
Java_Dislin_getbpp (JNIEnv *env, jobject object)
{ return getbpp ();
}

JNIEXPORT jint JNICALL
Java_Dislin_getclr (JNIEnv *env, jobject object)
{ return getclr ();
}

JNIEXPORT jint JNICALL
Java_Dislin_getclp (JNIEnv *env, jobject object, jint i)
{ int i1, i2, i3, i4;
  getclp (&i1, &i2, &i3, &i4);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else if (i == 3)
    return i3;
  else if (i == 4)
    return i4;
  else 
    return -1;
}

JNIEXPORT jint JNICALL
Java_Dislin_getdig (JNIEnv *env, jobject object, jint i)
{ int i1, i2, i3;
  getdig (&i1, &i2, &i3);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else if (i == 3)
    return i3;
  else 
    return -1;
}

JNIEXPORT jstring JNICALL
Java_Dislin_getdsp (JNIEnv *env, jobject object)
{ 
  char *p;
  p = getdsp ();
  return (*env)->NewStringUTF(env, p);
}

JNIEXPORT jstring JNICALL
Java_Dislin_getfil (JNIEnv *env, jobject object)
{ 
  char *p;
  p = getfil ();
  return (*env)->NewStringUTF(env, p);
}

JNIEXPORT jfloat JNICALL
Java_Dislin_getgrf (JNIEnv *env, jobject object, jint i, jstring s)
{ float a, e, or, step;
  const char *str = (*env)->GetStringUTFChars(env, s, 0);
  getgrf (&a, &e, &or, &step, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
  if (i == 1)
    return a;
  else if (i == 2)
    return e;
  else if (i == 3)
    return or;
  else if (i == 4)
    return step;
  else
    return -1.;
}

JNIEXPORT jint JNICALL
Java_Dislin_gethgt (JNIEnv *env, jobject object)
{ return gethgt ();
}

JNIEXPORT jfloat JNICALL
Java_Dislin_getind (JNIEnv *env, jobject object, jint idx, jint i)
{ float x1, x2, x3;
  getind (idx, &x1, &x2, &x3);
  if (i == 1)
    return x1;
  else if (i == 2)
    return x2;
  else if (i == 3)
    return x3;
  else 
    return -1;
}

JNIEXPORT jstring JNICALL
Java_Dislin_getlab (JNIEnv *env, jobject object, jint i)
{ char cx[5], cy[5], cz[5];
  getlab (cx, cy, cz);

  if (i == 1)
    return (*env)->NewStringUTF(env, cx);
  else if (i == 2)
    return (*env)->NewStringUTF(env, cy);
  else if (i == 3)
    return (*env)->NewStringUTF(env, cz);
}

JNIEXPORT jint JNICALL
Java_Dislin_getlen (JNIEnv *env, jobject object, jint i)
{ int i1, i2, i3;
  getlen (&i1, &i2, &i3);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else if (i == 3)
    return i3;
  else 
    return -1;
}

JNIEXPORT jint JNICALL
Java_Dislin_getlev (JNIEnv *env, jobject object)
{ return getlev ();
}

JNIEXPORT jint JNICALL
Java_Dislin_getlin (JNIEnv *env, jobject object)
{ return getlin ();
}

JNIEXPORT void JNICALL 
Java_Dislin_getmat (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jfloatArray arr2, jfloatArray arr3,
                   jint n, jfloatArray arr4, jint nx, jint ny, jfloat zval,
                   jintArray arr5, jfloatArray arr6)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *zray = (*env)->GetFloatArrayElements(env, arr3, 0);
  jfloat *zmat = (*env)->GetFloatArrayElements(env, arr4, 0);
  jint   *imat = (*env)->GetIntArrayElements(env, arr5, 0);
  jfloat *wmat = (*env)->GetFloatArrayElements(env, arr6, 0);
  getmat ((float *) xray, (float *) yray, (float *) zray, n, (float *) zmat, 
          nx, ny, zval, (int *) imat, (float *) wmat);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, zray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr4, zmat, 0);
  (*env)->ReleaseIntArrayElements(env, arr5, imat, 0);
  (*env)->ReleaseFloatArrayElements(env, arr6, wmat, 0);
}

JNIEXPORT jstring JNICALL
Java_Dislin_getmfl (JNIEnv *env, jobject object)
{ 
  char *p;
  p = getmfl ();
  return (*env)->NewStringUTF(env, p);
}

JNIEXPORT jint JNICALL
Java_Dislin_getor (JNIEnv *env, jobject object, jint i)
{ int i1, i2;
  getor (&i1, &i2);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else 
    return -1;
}

JNIEXPORT jint JNICALL
Java_Dislin_getpag (JNIEnv *env, jobject object, jint i)
{ int i1, i2;
  getpag (&i1, &i2);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else 
    return -1;
}

JNIEXPORT jint JNICALL
Java_Dislin_getpat (JNIEnv *env, jobject object)
{ return (int) getpat ();
}

JNIEXPORT jint JNICALL
Java_Dislin_getplv (JNIEnv *env, jobject object)
{ return getplv ();
}

JNIEXPORT jint JNICALL
Java_Dislin_getpos (JNIEnv *env, jobject object, jint i)
{ int i1, i2;
  getpos (&i1, &i2);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else 
    return -1;
}

JNIEXPORT jfloat JNICALL
Java_Dislin_getrgb (JNIEnv *env, jobject object, jint i)
{ float x1, x2, x3;
  getrgb (&x1, &x2, &x3);
  if (i == 1)
    return x1;
  else if (i == 2)
    return x2;
  else if (i == 3)
    return x3;
  else 
    return -1;
}

JNIEXPORT jint JNICALL
Java_Dislin_getran (JNIEnv *env, jobject object, jint i)
{ int i1, i2;
  getran (&i1, &i2);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else 
    return -1;
}

JNIEXPORT jint JNICALL
Java_Dislin_getres (JNIEnv *env, jobject object, jint i)
{ int i1, i2;
  getres (&i1, &i2);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else 
    return -1;
}

JNIEXPORT jint JNICALL
Java_Dislin_getscl (JNIEnv *env, jobject object, jint i)
{ int i1, i2, i3;
  getscl (&i1, &i2, &i3);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else if (i == 3)
    return i3;
  else 
    return -1;
}

JNIEXPORT jint JNICALL
Java_Dislin_getsp1 (JNIEnv *env, jobject object, jint i)
{ int i1, i2, i3;
  getsp1 (&i1, &i2, &i3);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else if (i == 3)
    return i3;
  else 
    return -1;
}

JNIEXPORT jint JNICALL
Java_Dislin_getsp2 (JNIEnv *env, jobject object, jint i)
{ int i1, i2, i3;
  getsp2 (&i1, &i2, &i3);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else if (i == 3)
    return i3;
  else 
    return -1;
}

JNIEXPORT jint JNICALL
Java_Dislin_getsym (JNIEnv *env, jobject object, jint i)
{ int i1, i2;
  getsym (&i1, &i2);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else 
    return -1;
}

JNIEXPORT jint JNICALL
Java_Dislin_gettcl (JNIEnv *env, jobject object, jint i)
{ int i1, i2;
  gettcl (&i1, &i2);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else 
    return -1;
}

JNIEXPORT jint JNICALL
Java_Dislin_gettic (JNIEnv *env, jobject object, jint i)
{ int i1, i2, i3;
  gettic (&i1, &i2, &i3);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else if (i == 3)
    return i3;
  else 
    return -1;
}

JNIEXPORT jint JNICALL
Java_Dislin_gettyp (JNIEnv *env, jobject object)
{ return gettyp ();
}

JNIEXPORT jint JNICALL
Java_Dislin_getuni (JNIEnv *env, jobject object)
{ FILE *fp; 
  
  fp = getuni ();
  if (fp == NULL)
    return 0;
  else
    return 6;
}

JNIEXPORT jfloat JNICALL
Java_Dislin_getver (JNIEnv *env, jobject object)
{ return getver ();
}

JNIEXPORT jint JNICALL
Java_Dislin_getvk (JNIEnv *env, jobject object, jint i)
{ int i1, i2, i3;
  getvk (&i1, &i2, &i3);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else if (i == 3)
    return i3;
  else 
    return -1;
}

JNIEXPORT jstring JNICALL
Java_Dislin_getvlt (JNIEnv *env, jobject object)
{ 
  char *p;
  p = getvlt ();
  return (*env)->NewStringUTF(env, p);
}

JNIEXPORT jint JNICALL
Java_Dislin_getwid (JNIEnv *env, jobject object)
{ return getwid ();
}

JNIEXPORT jint JNICALL
Java_Dislin_getwin (JNIEnv *env, jobject object, jint i)
{ int i1, i2, i3, i4;
  getwin (&i1, &i2, &i3, &i4);
  if (i == 1)
    return i1;
  else if (i == 2)
    return i2;
  else if (i == 3)
    return i3;
  else if (i == 4)
    return i4;
  else 
    return -1;
}

JNIEXPORT jint JNICALL
Java_Dislin_getxid (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  int nl;
  nl = getxid ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return nl;
}

JNIEXPORT void JNICALL
Java_Dislin_gothic (JNIEnv *env, jobject object)
{
  gothic ();
}

JNIEXPORT void JNICALL 
Java_Dislin_grace (JNIEnv *env, jobject object, jint i)
{
  grace (i);
}

JNIEXPORT void JNICALL
Java_Dislin_graf (JNIEnv *env, jobject object, 
                  jfloat xa, jfloat xe, jfloat xor, jfloat xstp,
                  jfloat ya, jfloat ye, jfloat yor, jfloat ystp)
{ graf (xa, xe, xor, xstp, ya, ye, yor, ystp);
}

JNIEXPORT void JNICALL
Java_Dislin_graf3 (JNIEnv *env, jobject object, 
                  jfloat xa, jfloat xe, jfloat xor, jfloat xstp,
                  jfloat ya, jfloat ye, jfloat yor, jfloat ystp,
                  jfloat za, jfloat ze, jfloat zor, jfloat zstp)
{ graf3 (xa, xe, xor, xstp, ya, ye, yor, ystp, za, ze, zor, zstp);
}

JNIEXPORT void JNICALL
Java_Dislin_graf3d (JNIEnv *env, jobject object, 
                  jfloat xa, jfloat xe, jfloat xor, jfloat xstp,
                  jfloat ya, jfloat ye, jfloat yor, jfloat ystp,
                  jfloat za, jfloat ze, jfloat zor, jfloat zstp)
{ graf3d (xa, xe, xor, xstp, ya, ye, yor, ystp, za, ze, zor, zstp);
}

JNIEXPORT void JNICALL
Java_Dislin_grafmp (JNIEnv *env, jobject object, 
                    jfloat xa, jfloat xe, jfloat xor, jfloat xstp,
                    jfloat ya, jfloat ye, jfloat yor, jfloat ystp)
{ grafmp (xa, xe, xor, xstp, ya, ye, yor, ystp);
}

JNIEXPORT void JNICALL
Java_Dislin_grffin (JNIEnv *env, jobject object)
{
  grffin ();
}

JNIEXPORT void JNICALL
Java_Dislin_grfini (JNIEnv *env, jobject object, 
                  jfloat x1, jfloat y1, jfloat z1,
                  jfloat x2, jfloat y2, jfloat z2,
                  jfloat x3, jfloat y3, jfloat z3)
{ grfini (x1, y1, z1, x2, y2, z2, x3, y3, z3);
}

JNIEXPORT void JNICALL 
Java_Dislin_grdpol (JNIEnv *env, jobject object, jint i, jint j)
{
  grdpol (i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_grid (JNIEnv *env, jobject object, jint i, jint j)
{
  grid (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_grid3d (JNIEnv *env, jobject object, jint i, jint j, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  grid3d (i, j, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_gridmp (JNIEnv *env, jobject object, jint i, jint j)
{
  gridmp (i, j);
}

JNIEXPORT jint JNICALL
Java_Dislin_gwgbox (JNIEnv *env, jobject object, jint i)
{ return gwgbox (i);
}

JNIEXPORT jint JNICALL
Java_Dislin_gwgbut (JNIEnv *env, jobject object, jint i)
{ return gwgbut (i);
}

JNIEXPORT jstring JNICALL
Java_Dislin_gwgfil (JNIEnv *env, jobject object, jint id)
{ char cstr[132];
  gwgfil (id, cstr);
  return (*env)->NewStringUTF(env, cstr);
}

JNIEXPORT jint JNICALL
Java_Dislin_gwglis (JNIEnv *env, jobject object, jint i)
{ return gwglis (i);
}

JNIEXPORT jfloat JNICALL
Java_Dislin_gwgscl (JNIEnv *env, jobject object, jint id)
{ return gwgscl (id);
}

JNIEXPORT jstring JNICALL
Java_Dislin_gwgtxt (JNIEnv *env, jobject object, jint id)
{ char cstr[512];
  gwgtxt (id, cstr);
  return (*env)->NewStringUTF(env, cstr);
}

JNIEXPORT void JNICALL 
Java_Dislin_height (JNIEnv *env, jobject object, jint i)
{
  height (i);
}

JNIEXPORT void JNICALL
Java_Dislin_helve (JNIEnv *env, jobject object)
{
  helve ();
}

JNIEXPORT void JNICALL
Java_Dislin_helves (JNIEnv *env, jobject object)
{
  helves ();
}

JNIEXPORT jint JNICALL 
Java_Dislin_histog (JNIEnv *env, jobject object, 
        jfloatArray arr1, jint nray, 
        jfloatArray arr2, jfloatArray arr3)
{ int n;

  jfloat *xray  = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *x2ray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *y2ray = (*env)->GetFloatArrayElements(env, arr3, 0);

  histog ((float *) xray, nray, (float *) x2ray, (float *) y2ray, &n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, x2ray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, y2ray, 0);
  return n;
}

JNIEXPORT void JNICALL 
Java_Dislin_hname (JNIEnv *env, jobject object, jint i)
{
  hname (i);
}

JNIEXPORT void JNICALL 
Java_Dislin_hsvrgb (JNIEnv *env, jobject object, jfloat x, jfloat y,
                    jfloat z, jfloatArray arr1)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  hsvrgb (x, y, z, &xray[0], &xray[1], &xray[2]);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_hsymbl (JNIEnv *env, jobject object, jint i)
{
  hsymbl (i);
}

JNIEXPORT void JNICALL 
Java_Dislin_htitle (JNIEnv *env, jobject object, jint i)
{
  htitle (i);
}

JNIEXPORT void JNICALL
Java_Dislin_hwfont (JNIEnv *env, jobject object)
{
  hwfont ();
}

JNIEXPORT void JNICALL 
Java_Dislin_hworig (JNIEnv *env, jobject object, jint i, jint j)
{
  hworig (i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_hwpage (JNIEnv *env, jobject object, jint i, jint j)
{
  hwpage (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_imgfin (JNIEnv *env, jobject object)
{
  imgfin ();
}

JNIEXPORT void JNICALL
Java_Dislin_imgini (JNIEnv *env, jobject object)
{
  imgini ();
}

JNIEXPORT void JNICALL 
Java_Dislin_inccrv (JNIEnv *env, jobject object, jint i)
{
  inccrv (i);
}

JNIEXPORT void JNICALL
Java_Dislin_incfil (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  incfil ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_incmrk (JNIEnv *env, jobject object, jint i)
{
  incmrk (i);
}

JNIEXPORT void JNICALL
Java_Dislin_intax (JNIEnv *env, jobject object)
{
  intax ();
}

JNIEXPORT jstring JNICALL
Java_Dislin_intcha (JNIEnv *env, jobject object, jint n)
{ char cstr[80];
  int nl;
  nl = intcha (n, cstr);
  return (*env)->NewStringUTF(env, cstr);
}

JNIEXPORT jint JNICALL
Java_Dislin_intlen (JNIEnv *env, jobject object, jint i)
{ return intlen (i);
}

JNIEXPORT jstring JNICALL
Java_Dislin_itmcat (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ char *p;
  int n1, n2;
  jstring s3;
  const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  n1 = trmlen ((char *) str1);
  n2 = trmlen ((char *) str2);
  p = (char *) malloc (n1 + n2 + 2);
  strcpy (p, (char *) str1);
  itmcat (p, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
  s3 = (*env)->NewStringUTF(env, p);
  free (p);
  return s3;
}

JNIEXPORT jint JNICALL
Java_Dislin_itmcnt(JNIEnv *env, jobject object, jstring s)
{ int i;
  const char *str = (*env)->GetStringUTFChars(env, s, 0);
  i = itmcnt ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return i;
}

JNIEXPORT jstring JNICALL
Java_Dislin_itmstr (JNIEnv *env, jobject object, jstring s, jint i)
{ char *p;
  const char *str = (*env)->GetStringUTFChars(env, s, 0);
  p = itmstr ((char *) str, i);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return (*env)->NewStringUTF(env, p);
}

JNIEXPORT void JNICALL
Java_Dislin_labclr (JNIEnv *env, jobject object, jint i, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  labclr (i, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_labdig (JNIEnv *env, jobject object, jint i, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  labdig (i, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_labdis (JNIEnv *env, jobject object, jint i, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  labdis (i, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_labels (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  labels ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_labjus (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  labjus ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_labpos (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  labpos ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_labtyp (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  labtyp ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_legclr (JNIEnv *env, jobject object)
{
  legclr ();
}

JNIEXPORT void JNICALL
Java_Dislin_legend (JNIEnv *env, jobject object, jstring s, jint n)
{ 
  legend (clegbf, n);
}

JNIEXPORT void JNICALL
Java_Dislin_legini (JNIEnv *env, jobject object, jstring s, jint nlin,
                    jint nmaxln)
{ int i;

  if (ilegop != 0) free (clegbf);
  clegbf = (char *) malloc (nlin * nmaxln + 1);

  for (i = 0; i < nlin * nmaxln; i++)
     clegbf[i] = ' ';
  clegbf[nlin*nmaxln] = '\0';

  ilegop = 1;
  legini (clegbf, nlin, nmaxln);
}

JNIEXPORT void JNICALL
Java_Dislin_leglin (JNIEnv *env, jobject object, jstring s1, 
                    jstring s2, jint ilin)
{ const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  leglin (clegbf, (char *) str2, ilin);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL 
Java_Dislin_legopt (JNIEnv *env, jobject object, jfloat x, jfloat y, jfloat z)
{
  legopt (x, y, z);
}

JNIEXPORT void JNICALL 
Java_Dislin_legpat (JNIEnv *env, jobject object, jint ityp, jint ithk,
                    jint isym, jint ipat, jint iclr, jint ilin)
{
  legpat (ityp, ithk, isym, ipat, iclr, ilin);
}

JNIEXPORT void JNICALL 
Java_Dislin_legpos (JNIEnv *env, jobject object, jint i, jint j)
{
  legpos (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_legtit (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  legtit ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_lfttit (JNIEnv *env, jobject object)
{
  lfttit ();
}

JNIEXPORT void JNICALL 
Java_Dislin_lincyc (JNIEnv *env, jobject object, jint i, jint j)
{
  lincyc (i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_line (JNIEnv *env, jobject object, jint nx, jint ny,
                    jint nu, jint nv)
{
  line (nx, ny, nu, nv);
}

JNIEXPORT void JNICALL
Java_Dislin_linesp (JNIEnv *env, jobject object, jfloat x)
{ linesp (x);
}

JNIEXPORT void JNICALL 
Java_Dislin_lintyp (JNIEnv *env, jobject object, jint i)
{
  lintyp (i);
}

JNIEXPORT void JNICALL 
Java_Dislin_linwid (JNIEnv *env, jobject object, jint i)
{
  linwid (i);
}

JNIEXPORT void JNICALL
Java_Dislin_lncap (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  lncap ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_lnjoin (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  lnjoin ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_lnmlt (JNIEnv *env, jobject object, jfloat x)
{ lnmlt (x);
}

JNIEXPORT void JNICALL
Java_Dislin_logtic (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  logtic ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_mapbas (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  mapbas ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_maplev (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  maplev ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_mapmod (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  mapmod ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_mappol (JNIEnv *env, jobject object, jfloat x, jfloat y)
{
  mappol (x, y);
}

JNIEXPORT void JNICALL 
Java_Dislin_mapref (JNIEnv *env, jobject object, jfloat x, jfloat y)
{
  mapref (x, y);
}

JNIEXPORT void JNICALL 
Java_Dislin_mapsph (JNIEnv *env, jobject object, jfloat x)
{
  mapsph (x);
}

JNIEXPORT void JNICALL 
Java_Dislin_marker (JNIEnv *env, jobject object, jint i)
{
  marker (i);
}

JNIEXPORT void JNICALL 
Java_Dislin_mdfmat (JNIEnv *env, jobject object, jint i, jint j, jfloat x)
{
  mdfmat (i, j, x);
}

JNIEXPORT void JNICALL
Java_Dislin_messag (JNIEnv *env, jobject object, jstring s, jint i, jint j)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  messag ((char *) str, i, j);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_metafl (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  metafl ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_mixalf (JNIEnv *env, jobject object)
{
  mixalf ();
}

JNIEXPORT void JNICALL
Java_Dislin_mixleg (JNIEnv *env, jobject object)
{
  mixleg ();
}

float moment (float *xray, int n, char *copt);

JNIEXPORT void JNICALL
Java_Dislin_mpaepl (JNIEnv *env, jobject object, jint i)
{
  mpaepl (i);
}

JNIEXPORT void JNICALL
Java_Dislin_mplang (JNIEnv *env, jobject object, jfloat x)
{ mplang (x);
}

JNIEXPORT void JNICALL 
Java_Dislin_mplclr (JNIEnv *env, jobject object, jint i, jint j)
{
  mplclr (i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_mplpos (JNIEnv *env, jobject object, jint i, jint j)
{
  mplpos (i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_mplsiz (JNIEnv *env, jobject object, jint i)
{
  mplsiz (i);
}

JNIEXPORT void JNICALL
Java_Dislin_msgbox (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  msgbox ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_mylab (JNIEnv *env, jobject object, jstring s1, jint i, 
                    jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  mylab ((char *) str1, i, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL 
Java_Dislin_myline (JNIEnv *env, jobject object, jintArray arr1, jint n)
{ jint *nxray = (*env)->GetIntArrayElements(env, arr1, 0);
  myline ((int *) nxray, n);
  (*env)->ReleaseIntArrayElements(env, arr1, nxray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_mypat (JNIEnv *env, jobject object, jint nx, jint ny, 
                                                 jint nw, jint nh)
{
  mypat (nx, ny, nw, nh);
}

JNIEXPORT void JNICALL 
Java_Dislin_myvlt (JNIEnv *env, jobject object, 
        jfloatArray arr1, jfloatArray arr2, jfloatArray arr3, jint n)
{
  jfloat *xrray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *xgray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *xbray = (*env)->GetFloatArrayElements(env, arr3, 0);
  myvlt ((float *) xrray, (float *) xgray, (float *) xbray, n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xrray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, xgray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, xbray, 0);
}

JNIEXPORT void JNICALL
Java_Dislin_namdis (JNIEnv *env, jobject object, jint i, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  namdis (i, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_name (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  name ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_namjus (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  namjus ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL 
Java_Dislin_neglog (JNIEnv *env, jobject object, jfloat x)
{
  neglog (x);
}

JNIEXPORT void JNICALL
Java_Dislin_newmix (JNIEnv *env, jobject object)
{
  newmix ();
}

JNIEXPORT void JNICALL
Java_Dislin_newpag (JNIEnv *env, jobject object)
{
  newpag ();
}

JNIEXPORT jint JNICALL
Java_Dislin_nlmess (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  int nl;
  nl = nlmess ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return nl;
}

JNIEXPORT jint JNICALL
Java_Dislin_nlnumb (JNIEnv *env, jobject object, jfloat x, jint i)
{ return nlnumb (x, i);
}

JNIEXPORT void JNICALL
Java_Dislin_noarln (JNIEnv *env, jobject object)
{
  noarln ();
}

JNIEXPORT void JNICALL
Java_Dislin_nobar (JNIEnv *env, jobject object)
{
  nobar ();
}

JNIEXPORT void JNICALL
Java_Dislin_nobgd (JNIEnv *env, jobject object)
{
  nobgd ();
}

JNIEXPORT void JNICALL
Java_Dislin_nochek (JNIEnv *env, jobject object)
{
  nochek ();
}

JNIEXPORT void JNICALL
Java_Dislin_noclip (JNIEnv *env, jobject object)
{
  noclip ();
}

JNIEXPORT void JNICALL
Java_Dislin_nofill (JNIEnv *env, jobject object)
{
  nofill ();
}

JNIEXPORT void JNICALL
Java_Dislin_nograf (JNIEnv *env, jobject object)
{
  nograf ();
}

JNIEXPORT void JNICALL
Java_Dislin_nohide (JNIEnv *env, jobject object)
{
  nohide ();
}

JNIEXPORT void JNICALL
Java_Dislin_noline (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  noline ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_number (JNIEnv *env, jobject object, jfloat x, jint n, 
                    jint i, jint j)
{ number (x, n, i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_numfmt (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  numfmt ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_numode (JNIEnv *env, jobject object, jstring s1, 
                    jstring s2, jstring s3, jstring s4)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  const char *str3 = (*env)->GetStringUTFChars(env, s3, 0);
  const char *str4 = (*env)->GetStringUTFChars(env, s4, 0);
  numode ((char *) str1, (char *) str2, (char *) str3, (char *) str4);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
  (*env)->ReleaseStringUTFChars(env, s3, str3);
  (*env)->ReleaseStringUTFChars(env, s4, str4);
}

JNIEXPORT jint JNICALL
Java_Dislin_nxlegn (JNIEnv *env, jobject object, jstring s)
{ return nxlegn (clegbf);
}

JNIEXPORT jint JNICALL
Java_Dislin_nxposn (JNIEnv *env, jobject object, jfloat x)
{ return nxposn (x);
}

JNIEXPORT jint JNICALL
Java_Dislin_nylegn (JNIEnv *env, jobject object, jstring s)
{ return nylegn (clegbf);
}

JNIEXPORT jint JNICALL
Java_Dislin_nyposn (JNIEnv *env, jobject object, jfloat x)
{ return nyposn (x);
}

JNIEXPORT jint JNICALL
Java_Dislin_nzposn (JNIEnv *env, jobject object, jfloat x)
{ return nzposn (x);
}

JNIEXPORT jint JNICALL
Java_Dislin_openflfl (JNIEnv *env, jobject object, jstring s, jint nu, 
                      jint irw)
{ int iret;
  const char *str = (*env)->GetStringUTFChars(env, s, 0);
  iret = openfl ((char *) str, nu, irw);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return iret;
}

JNIEXPORT void JNICALL 
Java_Dislin_opnwin (JNIEnv *env, jobject object, jint i)
{
  opnwin (i);
}

JNIEXPORT void JNICALL 
Java_Dislin_origin (JNIEnv *env, jobject object, jint i, jint j)
{
  origin (i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_page (JNIEnv *env, jobject object, jint i, jint j)
{
  page (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_pagera (JNIEnv *env, jobject object)
{
  pagera ();
}

JNIEXPORT void JNICALL
Java_Dislin_paghdr (JNIEnv *env, jobject object, jstring s1, jstring s2,
                    jint i, jint j)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  paghdr ((char *) str1, (char *) str2, i, j);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_pagmod (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  pagmod ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_patcyc (JNIEnv *env, jobject object, jint i, jint j)
{
  patcyc (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_penwid (JNIEnv *env, jobject object, jfloat x)
{ penwid (x);
}

JNIEXPORT void JNICALL 
Java_Dislin_pie (JNIEnv *env, jobject object, jint nxm, jint nym,
                    jint nr, jfloat a, jfloat b)
{
  pie (nxm, nym, nr, a, b);
}

JNIEXPORT void JNICALL
Java_Dislin_pieexp (JNIEnv *env, jobject object)
{
  pieexp ();
}

JNIEXPORT void JNICALL
Java_Dislin_piegrf (JNIEnv *env, jobject object, jstring s, jint nlin,
                    jfloatArray arr1, jint nseg)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  
  if (nlin == 0)
    piegrf (" ", nlin, xray, nseg);
  else 
    piegrf (clegbf, nlin, xray, nseg);

  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
}

JNIEXPORT void JNICALL
Java_Dislin_pielab (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  pielab ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_pievec (JNIEnv *env, jobject object, jint i, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  pievec (i, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_point (JNIEnv *env, jobject object, jint nx, jint ny, 
                                                 jint nw, jint nh, jint ncol)
{
  point (nx, ny, nw, nh, ncol);
}

JNIEXPORT void JNICALL
Java_Dislin_polcrv (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  polcrv ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_pos2pt (JNIEnv *env, jobject object, jfloat x, jfloat y,
                    jfloatArray arr1)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  pos2pt (x, y, &xray[0], &xray[1]);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_pos3pt (JNIEnv *env, jobject object, jfloat x, jfloat y,
                    jfloat z, jfloatArray arr1)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  pos3pt (x, y, z, &xray[0], &xray[1], &xray[2]);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
}

JNIEXPORT jint JNICALL
Java_Dislin_posifl (JNIEnv *env, jobject object, jint i, jint j)
{ return posifl (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_projct (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  projct ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_psfont (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  psfont ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT jint JNICALL 
Java_Dislin_readfl (JNIEnv *env, jobject object, jint nu, jbyteArray arr1, 
                    jint n)
{ int iret;
  jbyte *cbuf = (*env)->GetByteArrayElements(env, arr1, 0);
  iret = readfl (nu, (unsigned char * ) cbuf, n);
  (*env)->ReleaseByteArrayElements(env, arr1, cbuf, 0);
  return iret;
}

JNIEXPORT void JNICALL 
Java_Dislin_recfll (JNIEnv *env, jobject object, jint nx, jint ny, 
                                                 jint nw, jint nh, jint ncol)
{
  recfll (nx, ny, nw, nh, ncol);
}

JNIEXPORT void JNICALL 
Java_Dislin_rectan (JNIEnv *env, jobject object, jint nx, jint ny, 
                                                 jint nw, jint nh)
{
  rectan (nx, ny, nw, nh);
}

JNIEXPORT void JNICALL 
Java_Dislin_rel3pt (JNIEnv *env, jobject object, jfloat x, jfloat y,
                    jfloat z, jfloatArray arr1)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  rel3pt (x, y, z, &xray[0], &xray[1]);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
}

JNIEXPORT void JNICALL
Java_Dislin_resatt (JNIEnv *env, jobject object)
{
  resatt ();
}

JNIEXPORT void JNICALL
Java_Dislin_reset (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  reset ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_revsrc (JNIEnv *env, jobject object)
{
  revscr ();
}

JNIEXPORT void JNICALL 
Java_Dislin_rgbhsv (JNIEnv *env, jobject object, jfloat x, jfloat y,
                    jfloat z, jfloatArray arr1)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  rgbhsv (x, y, z, &xray[0], &xray[1], &xray[2]);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
}

JNIEXPORT void JNICALL
Java_Dislin_rgtlab (JNIEnv *env, jobject object)
{
  rgtlab ();
}

JNIEXPORT void JNICALL
Java_Dislin_rimage (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  rimage ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_rlarc (JNIEnv *env, jobject object, jfloat x, jfloat y,
                    jfloat xa, jfloat xb, jfloat a, jfloat b, jfloat t)
{
  rlarc (x, y, xa, xb, a, b, t);
}

JNIEXPORT void JNICALL 
Java_Dislin_rlarea (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jfloatArray arr2, jint n)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  rlarea ((float *) xray, (float *) yray, n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_rlcirc (JNIEnv *env, jobject object, jfloat x, jfloat y,
                    jfloat r)
{
  rlcirc (x, y, r);
}

JNIEXPORT void JNICALL 
Java_Dislin_rlconn (JNIEnv *env, jobject object, jfloat x, jfloat y)
{
  rlconn (x, y);
}

JNIEXPORT void JNICALL 
Java_Dislin_rlell (JNIEnv *env, jobject object, jfloat x, jfloat y,
                    jfloat a, jfloat b)
{
  rlell (x, y, a, b);
}

JNIEXPORT void JNICALL 
Java_Dislin_rline (JNIEnv *env, jobject object, jfloat x, jfloat y,
                                                jfloat u, jfloat v)
{
  rline (x, y, u, v);
}

JNIEXPORT void JNICALL
Java_Dislin_rlmess (JNIEnv *env, jobject object, jstring s, jfloat x, 
                    jfloat y)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  rlmess ((char *) str, x, y);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_rlnumb (JNIEnv *env, jobject object, jfloat x, jint ndig,
                    jfloat xp, jfloat yp)
{
  rlnumb (x, ndig, xp, yp);
}

JNIEXPORT void JNICALL 
Java_Dislin_rlpie (JNIEnv *env, jobject object, jfloat x, jfloat y,
                    jfloat r, jfloat a, jfloat b)
{
  rlpie (x, y, r, a, b);
}

JNIEXPORT void JNICALL 
Java_Dislin_rlpoin (JNIEnv *env, jobject object, jfloat x, jfloat y,
                    jint nb, jint nh, jint ncol)
{
  rlpoin (x, y, nb, nh, ncol);
}

JNIEXPORT void JNICALL 
Java_Dislin_rlrec (JNIEnv *env, jobject object, jfloat x, jfloat y,
                                                jfloat xw, jfloat xh)
{
  rlrec (x, y, xw, xh);
}

JNIEXPORT void JNICALL 
Java_Dislin_rlrnd (JNIEnv *env, jobject object, jfloat x, jfloat y,
                   jfloat xw, jfloat xh, jint i)
{
  rlrnd (x, y, xw, xh, i);
}

JNIEXPORT void JNICALL 
Java_Dislin_rlsec (JNIEnv *env, jobject object, jfloat x, jfloat y,
                   jfloat r1, jfloat r2, jfloat a, jfloat b, jint i)
{
  rlsec (x, y, r1, r2, a, b, i);
}

JNIEXPORT void JNICALL 
Java_Dislin_rlstrt (JNIEnv *env, jobject object, jfloat x, jfloat y)
{
  rlstrt (x, y);
}

JNIEXPORT void JNICALL 
Java_Dislin_rlsymb (JNIEnv *env, jobject object, jint i, jfloat x, jfloat y)
{
  rlsymb (i, x, y);
}

JNIEXPORT void JNICALL 
Java_Dislin_rlvec (JNIEnv *env, jobject object, jfloat x, jfloat y,
                              jfloat u, jfloat v, jint i)
{
  rlvec (x, y, u, v, i);
}

JNIEXPORT void JNICALL 
Java_Dislin_rndrec (JNIEnv *env, jobject object, jint nx, jint ny, 
                                   jint nw, jint nh, jint irnd)
{
  rndrec (nx, ny, nw, nh, irnd);
}

JNIEXPORT jint JNICALL
Java_Dislin_rpixel (JNIEnv *env, jobject object, jint i, jint j)
{ int iret;
  rpixel (i, j, &iret);
  return iret;
}

JNIEXPORT void JNICALL 
Java_Dislin_rpixls (JNIEnv *env, jobject object, jbyteArray arr1, jint ix,
                    jint iy, jint nw, jint nh)
{ jbyte *cbuf = (*env)->GetByteArrayElements(env, arr1, 0);
  rpixls ((unsigned char * ) cbuf, ix, iy, nw, nh);
  (*env)->ReleaseByteArrayElements(env, arr1, cbuf, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_rpxrow (JNIEnv *env, jobject object, jbyteArray arr1, jint ix,
                    jint iy, jint n)
{ jbyte *cbuf = (*env)->GetByteArrayElements(env, arr1, 0);
  rpxrow ((unsigned char * ) cbuf, ix, iy, n);
  (*env)->ReleaseByteArrayElements(env, arr1, cbuf, 0);
}

JNIEXPORT void JNICALL
Java_Dislin_rtiff (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  rtiff ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_rvynam (JNIEnv *env, jobject object)
{
  rvynam ();
}

JNIEXPORT void JNICALL
Java_Dislin_scale (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  scale ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_sclfac (JNIEnv *env, jobject object, jfloat x)
{ sclfac (x);
}

JNIEXPORT void JNICALL
Java_Dislin_sclmod (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  sclmod ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_scrmod (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  scrmod ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_sector (JNIEnv *env, jobject object, jint nx, jint ny,
                    jint nr1, jint nr2, jfloat a, jfloat b, jint ncol)
{
  sector (nx, ny, nr1, nr2, a, b, ncol);
}

JNIEXPORT void JNICALL 
Java_Dislin_selwin (JNIEnv *env, jobject object, jint i)
{
  selwin (i);
}

JNIEXPORT void JNICALL
Java_Dislin_sendbf (JNIEnv *env, jobject object)
{
  sendbf ();
}

void  sendok (void);

JNIEXPORT void JNICALL
Java_Dislin_serif (JNIEnv *env, jobject object)
{
  serif ();
}

JNIEXPORT void JNICALL
Java_Dislin_setbas (JNIEnv *env, jobject object, jfloat x)
{ setbas (x);
}

JNIEXPORT void JNICALL 
Java_Dislin_setclr (JNIEnv *env, jobject object, jint i)
{
  setclr (i);
}

JNIEXPORT void JNICALL
Java_Dislin_setexp (JNIEnv *env, jobject object, jfloat x)
{ setexp (x);
}

JNIEXPORT void JNICALL
Java_Dislin_setfil (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  setfil ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_setgrf (JNIEnv *env, jobject object, jstring s1, 
                    jstring s2, jstring s3, jstring s4)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  const char *str3 = (*env)->GetStringUTFChars(env, s3, 0);
  const char *str4 = (*env)->GetStringUTFChars(env, s4, 0);
  setgrf ((char *) str1, (char *) str2, (char *) str3, (char *) str4);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
  (*env)->ReleaseStringUTFChars(env, s3, str3);
  (*env)->ReleaseStringUTFChars(env, s4, str4);
}

JNIEXPORT void JNICALL
Java_Dislin_setind (JNIEnv *env, jobject object, jint i, jfloat xr,
                    jfloat xg, jfloat xb)
{ setind (i, xr, xg, xb);
}

JNIEXPORT void JNICALL
Java_Dislin_setmix (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  setmix ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_setpag (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  setpag ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_setres (JNIEnv *env, jobject object, jint i, jint j)
{
  setres (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_setrgb (JNIEnv *env, jobject object, jfloat r, jfloat g, jfloat b)
{ setrgb (r, g, b);
}

JNIEXPORT void JNICALL 
Java_Dislin_setscl (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jint n, jstring s)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  const char *str = (*env)->GetStringUTFChars(env, s, 0);
  setscl ((float *) xray, n, (char *) str);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_setvlt (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  setvlt ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_setxid (JNIEnv *env, jobject object, jint i, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  setxid (i, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_shdcha (JNIEnv *env, jobject object)
{
  shdcha ();
}

JNIEXPORT void JNICALL 
Java_Dislin_shdcrv (JNIEnv *env, jobject object, 
                    jfloatArray arr1, jfloatArray arr2, jint n1,
                    jfloatArray arr3, jfloatArray arr4, jint n2)
{ jfloat *x1ray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *y1ray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *x2ray = (*env)->GetFloatArrayElements(env, arr3, 0);
  jfloat *y2ray = (*env)->GetFloatArrayElements(env, arr4, 0);
  shdcrv ((float *) x1ray, (float *) y1ray, n1,
          (float *) x2ray, (float *) y2ray, n2);
  (*env)->ReleaseFloatArrayElements(env, arr1, x1ray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, y1ray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, x2ray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr4, y2ray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_shdeur (JNIEnv *env, jobject object, jintArray arr1, 
                    jintArray arr2, jintArray arr3, jint n)
{ jint *inray = (*env)->GetIntArrayElements(env, arr1, 0);
  jint *ipray = (*env)->GetIntArrayElements(env, arr2, 0);
  jint *icray = (*env)->GetIntArrayElements(env, arr2, 0);
  long *p;
  int i;
  p = (long *) calloc (n, sizeof (long));
  for (i = 0; i < n; i++)
    p[i] = ipray[i];
 
  shdeur ((int *) inray, p, (int *) icray, n);
  (*env)->ReleaseIntArrayElements(env, arr1, inray, 0);
  (*env)->ReleaseIntArrayElements(env, arr2, ipray, 0);
  (*env)->ReleaseIntArrayElements(env, arr3, icray, 0);
  free (p);
}

JNIEXPORT void JNICALL
Java_Dislin_shdmap (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  shdmap ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_shdmod (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  shdmod ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL 
Java_Dislin_shdpat (JNIEnv *env, jobject object, jint i)
{
  shdpat ((long) i);
}

JNIEXPORT void JNICALL
Java_Dislin_shield (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  shield ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL 
Java_Dislin_shlcir (JNIEnv *env, jobject object, jint nx, jint ny, 
                                        jint nr)
{
  shlcir (nx, ny, nr);
}

JNIEXPORT void JNICALL 
Java_Dislin_shldel (JNIEnv *env, jobject object, jint i)
{
  shldel (i);
}

JNIEXPORT void JNICALL 
Java_Dislin_shlell (JNIEnv *env, jobject object, jint nx, jint ny, 
                                        jint na, jint nb, jfloat t)
{
  shlell (nx, ny, na, nb, t);
}

JNIEXPORT jint JNICALL
Java_Dislin_shlind (JNIEnv *env, jobject object)
{ return shlind ();
}

JNIEXPORT void JNICALL 
Java_Dislin_shlpie (JNIEnv *env, jobject object, jint nx, jint ny, 
                                        jint nr, jfloat a, jfloat b)
{
  shlpie (nx, ny, nr, a, b);
}

JNIEXPORT void JNICALL 
Java_Dislin_shlpol (JNIEnv *env, jobject object, jintArray arr1, 
                    jintArray arr2, jint n)
{
  jint *nxray = (*env)->GetIntArrayElements(env, arr1, 0);
  jint *nyray = (*env)->GetIntArrayElements(env, arr2, 0);
  shlpol ((int *) nxray, (int *) nyray, n);
  (*env)->ReleaseIntArrayElements(env, arr1, nxray, 0);
  (*env)->ReleaseIntArrayElements(env, arr2, nyray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_shlrct (JNIEnv *env, jobject object, jint nx, jint ny, 
                                        jint nw, jint nh, jfloat t)
{
  shlrct (nx, ny, nw, nh, t);
}

JNIEXPORT void JNICALL 
Java_Dislin_shlrec (JNIEnv *env, jobject object, jint nx, jint ny, 
                                                 jint nw, jint nh)
{
  shlrec (nx, ny, nw, nh);
}

JNIEXPORT void JNICALL 
Java_Dislin_shlres (JNIEnv *env, jobject object, jint i)
{
  shlres (i);
}

JNIEXPORT void JNICALL
Java_Dislin_shlsur (JNIEnv *env, jobject object)
{
  shlsur ();
}

JNIEXPORT void JNICALL
Java_Dislin_shlvis (JNIEnv *env, jobject object, jint i, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  shlvis (i, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_simplx (JNIEnv *env, jobject object)
{
  simplx ();
}

int   skipfl (int nu, int nbyte); 
void  smxalf (char *calph, char *c1, char *c2, int n);

JNIEXPORT void JNICALL
Java_Dislin_solid (JNIEnv *env, jobject object)
{
  solid ();
}

JNIEXPORT void JNICALL
Java_Dislin_sortr1 (JNIEnv *env, jobject object, jfloatArray arr1, jint n,
                    jstring s)
{ 
  jfloat *xray  = (*env)->GetFloatArrayElements(env, arr1, 0);
  const char *str = (*env)->GetStringUTFChars(env, s, 0);
  sortr1 ((float *) xray, n, (char *) str);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_sortr2 (JNIEnv *env, jobject object, jfloatArray arr1, 
                    jfloatArray arr2, jint n, jstring s)
{ 
  jfloat *xray  = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray  = (*env)->GetFloatArrayElements(env, arr2, 0);
  const char *str = (*env)->GetStringUTFChars(env, s, 0);
  sortr2 ((float *) xray, (float *) yray, n, (char *) str);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT jint JNICALL 
Java_Dislin_spline (JNIEnv *env, jobject object, 
        jfloatArray arr1, jfloatArray arr2, jint nray, 
        jfloatArray arr3, jfloatArray arr4)
{ int n;

  jfloat *xray  = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray  = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *x2ray = (*env)->GetFloatArrayElements(env, arr3, 0);
  jfloat *y2ray = (*env)->GetFloatArrayElements(env, arr4, 0);

  spline ((float *) xray, (float *) yray, nray,
          (float *) x2ray, (float *) y2ray, &n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, x2ray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr4, y2ray, 0);
  return n;
}

JNIEXPORT void JNICALL 
Java_Dislin_splmod (JNIEnv *env, jobject object, jint i, jint j)
{
  splmod (i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_strt3d (JNIEnv *env, jobject object, jfloat x, jfloat y, jfloat z)
{
  strt3d (x, y, z);
}

JNIEXPORT void JNICALL 
Java_Dislin_strtpt (JNIEnv *env, jobject object, jfloat x, jfloat y)
{
  strtpt (x, y);
}

JNIEXPORT void JNICALL 
Java_Dislin_surclr (JNIEnv *env, jobject object, jint i, jint j)
{
  surclr (i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_surfce (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jint n, jfloatArray arr2, jint m,
                   jfloatArray arr3)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *zmat = (*env)->GetFloatArrayElements(env, arr3, 0);
  surfce ((float *) xray, n, (float *) yray, m, (float *) zmat);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, zmat, 0);
}

/*
JNIEXPORT void JNICALL
Java_Dislin_surfcp (JNIEnv *env, jobject object, jstring s,
                    jfloat a1, jfloat a2, jfloat astp,
                    jfloat b1, jfloat b2, jfloat bstp)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  jclass cls = (*env)->GetObjectClass (env, object);
  jmethodID mid = (*env)->GetStaticMethodID (env, cls, "myfunc", "(I)V");
  printf ("mid: %d\n", mid);
  return;
  surfcp (funcbck, a1, a2, astp, b1, b2, bstp);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

float funcbck (float x, float y, int iopt)
{ 
  return 0.;
}

float funcbck2 (float x, float y)
{ float xv = 0.;
  return xv;
}

void  surfun (float (*zfun)(float x, float y), int ixpts, float xdel, 
                     int iypts, float ydel);
*/

JNIEXPORT void JNICALL 
Java_Dislin_surmat (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jint nx, jint ny, jint ipts, jint jpts)
{
  jfloat *zmat = (*env)->GetFloatArrayElements(env, arr1, 0);
  surmat ((float *) zmat, nx, ny, ipts, jpts);
  (*env)->ReleaseFloatArrayElements(env, arr1, zmat, 0);
}

JNIEXPORT void JNICALL
Java_Dislin_surmsh (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  surmsh ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_surshd (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jint n, jfloatArray arr2, jint m,
                   jfloatArray arr3)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *zmat = (*env)->GetFloatArrayElements(env, arr3, 0);
  surshd ((float *) xray, n, (float *) yray, m, (float *) zmat);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, zmat, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_sursze (JNIEnv *env, jobject object, jfloat xmin, jfloat xmax, 
                    jfloat ymin, jfloat ymax)
{
  sursze (xmin, xmax, ymin, ymax);
}

JNIEXPORT void JNICALL
Java_Dislin_survis (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  survis ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_swgbox (JNIEnv *env, jobject object, jint i, jint j)
{
  swgbox (i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_swgbut (JNIEnv *env, jobject object, jint i, jint j)
{
  swgbut (i, j);
}

void  swgcb  (int id, void (*callbck) (int i, int *ir), int *iray);

JNIEXPORT void JNICALL
Java_Dislin_swgfil (JNIEnv *env, jobject object, jint i, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  swgfil (i, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_swgfnt (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  swgfnt ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_swghlp (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  swghlp ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_swgjus (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  swgjus ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL 
Java_Dislin_swglis (JNIEnv *env, jobject object, jint i, jint j)
{
  swglis (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_swgmix (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  swgmix ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_swgmod (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  swgmod ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_swgmrg (JNIEnv *env, jobject object, jint i, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  swgmrg (i, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_swgoff (JNIEnv *env, jobject object, jint i, jint j)
{
  swgoff (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_swgpop (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  swgpop ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_swgpos (JNIEnv *env, jobject object, jint i, jint j)
{
  swgpos (i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_swgscl (JNIEnv *env, jobject object, jint i, jfloat x)
{
  swgscl (i, x);
}

JNIEXPORT void JNICALL 
Java_Dislin_swgsiz (JNIEnv *env, jobject object, jint i, jint j)
{
  swgsiz (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_swgtit (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  swgtit ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_swgtxt (JNIEnv *env, jobject object, jint i, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  swgtxt (i, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_swgtyp (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  swgtyp ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL 
Java_Dislin_swgwin (JNIEnv *env, jobject object, jint nx, jint ny, 
                                                 jint nw, jint nh)
{
  swgwin (nx, ny, nw, nh);
}

JNIEXPORT void JNICALL 
Java_Dislin_swgwth (JNIEnv *env, jobject object, jint i)
{
  swgwth (i);
}

JNIEXPORT void JNICALL 
Java_Dislin_symbol (JNIEnv *env, jobject object, jint i, jint nx, jint ny)
{
  symbol (i, nx, ny);
}

JNIEXPORT void JNICALL
Java_Dislin_symfil (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  symfil ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_symrot (JNIEnv *env, jobject object, jfloat x)
{ symrot (x);
}

JNIEXPORT jint JNICALL
Java_Dislin_tellfl (JNIEnv *env, jobject object, jint i)
{ return tellfl (i);
}
 
JNIEXPORT void JNICALL 
Java_Dislin_thkcrv (JNIEnv *env, jobject object, jint i)
{
  thkcrv (i);
}

JNIEXPORT void JNICALL
Java_Dislin_ticks (JNIEnv *env, jobject object, jint i, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  ticks (i, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_ticlen (JNIEnv *env, jobject object, jint i, jint j)
{
  ticlen (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_ticpos (JNIEnv *env, jobject object, jstring s1, jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  ticpos ((char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL 
Java_Dislin_tiforg (JNIEnv *env, jobject object, jint i, jint j)
{
  tiforg (i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_tifwin (JNIEnv *env, jobject object, jint nx, jint ny, 
                                                 jint nw, jint nh)
{
  tifwin (nx, ny, nw, nh);
}

JNIEXPORT void JNICALL
Java_Dislin_timopt (JNIEnv *env, jobject object)
{
  timopt ();
}

JNIEXPORT void JNICALL
Java_Dislin_titjus (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  titjus ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_title (JNIEnv *env, jobject object)
{
  title ();
}

JNIEXPORT void JNICALL
Java_Dislin_titlin (JNIEnv *env, jobject object, jstring s, jint i)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  titlin ((char *) str, i);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_titpos (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  titpos ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_trfco1 (JNIEnv *env, jobject object, jfloatArray arr1, jint n,
                    jstring s1, jstring s2)
{ 
  jfloat *xray  = (*env)->GetFloatArrayElements(env, arr1, 0);
  const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  trfco1 ((float *) xray, n, (char *) str1, (char *) str2);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_trfco2 (JNIEnv *env, jobject object, jfloatArray arr1, 
                    jfloatArray arr2, jint n, jstring s1, jstring s2)
{ 
  jfloat *xray  = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray  = (*env)->GetFloatArrayElements(env, arr2, 0);
  const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  trfco2 ((float *) xray, (float *) yray, n, (char *) str1, (char *) str2);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL
Java_Dislin_trfco3 (JNIEnv *env, jobject object, jfloatArray arr1, 
                    jfloatArray arr2, jfloatArray arr3, jint n, 
                    jstring s1, jstring s2)
{ 
  jfloat *xray  = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray  = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *zray  = (*env)->GetFloatArrayElements(env, arr3, 0);
  const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  trfco3 ((float *) xray, (float *) yray, (float *) zray, n, 
          (char *) str1, (char *) str2);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, zray, 0);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
}

JNIEXPORT void JNICALL 
Java_Dislin_trfrel (JNIEnv *env, jobject object, 
                   jfloatArray arr1, jfloatArray arr2, jint n)
{ jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  trfrel ((float *) xray, (float *) yray, n);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
}

JNIEXPORT void JNICALL
Java_Dislin_trfres (JNIEnv *env, jobject object)
{
  trfres ();
}

JNIEXPORT void JNICALL 
Java_Dislin_trfrot (JNIEnv *env, jobject object, jfloat x, jint i, jint j)
{
  trfrot (x, i, j);
}

JNIEXPORT void JNICALL 
Java_Dislin_trfscl (JNIEnv *env, jobject object, jfloat x, jfloat y)
{
  trfscl (x, y);
}

JNIEXPORT void JNICALL 
Java_Dislin_trfshf (JNIEnv *env, jobject object, jint i, jint j)
{
  trfshf (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_triplx (JNIEnv *env, jobject object)
{
  triplx ();
}

JNIEXPORT jint JNICALL
Java_Dislin_trmlen (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  int nl;
  nl = trmlen((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return nl;
}

JNIEXPORT void JNICALL
Java_Dislin_txtjus (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  txtjus ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_unit (JNIEnv *env, jobject object, jint i)
{ 
  if (i == 0)
    unit (NULL);
  else
    unit (stdout);
}

JNIEXPORT void JNICALL
Java_Dislin_upstr (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  upstr ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_vang3d (JNIEnv *env, jobject object, jfloat x)
{ vang3d (x);
}

JNIEXPORT void JNICALL 
Java_Dislin_vclp3d (JNIEnv *env, jobject object, jfloat x, jfloat y)
{
  vclp3d (x, y);
}

JNIEXPORT void JNICALL 
Java_Dislin_vector (JNIEnv *env, jobject object, jint nx1, jint ny1,
                    jint nx2, jint ny2, jint ivec)
{
  vector (nx1, ny1, nx2, ny2, ivec);
}

JNIEXPORT void JNICALL 
Java_Dislin_vectr3 (JNIEnv *env, jobject object, jfloat x1, jfloat y1,
                    jfloat z1, jfloat x2, jfloat y2, jfloat z2, jint i)
{
  vectr3 (x1, y1, z1, x2, y2, z2, i);
}

JNIEXPORT void JNICALL
Java_Dislin_vfoc3d (JNIEnv *env, jobject object, jfloat x, jfloat y, 
                    jfloat z, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  vfoc3d (x, y, z, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_view3d (JNIEnv *env, jobject object, jfloat x, jfloat y, 
                    jfloat z, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  view3d (x, y, z, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_vkxbar (JNIEnv *env, jobject object, jint i)
{
  vkxbar (i);
}

JNIEXPORT void JNICALL 
Java_Dislin_vkybar (JNIEnv *env, jobject object, jint i)
{
  vkybar (i);
}

JNIEXPORT void JNICALL 
Java_Dislin_vkytit (JNIEnv *env, jobject object, jint i)
{
  vkytit (i);
}

JNIEXPORT void JNICALL
Java_Dislin_vup3d (JNIEnv *env, jobject object, jfloat x)
{ vup3d (x);
}

JNIEXPORT jint JNICALL
Java_Dislin_wgapp (JNIEnv *env, jobject object, jint ip, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  int id;
  id = wgapp (ip, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return id;
}

JNIEXPORT jint JNICALL
Java_Dislin_wgbas (JNIEnv *env, jobject object, jint ip, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  int id;
  id = wgbas (ip, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return id;
}

JNIEXPORT jint JNICALL
Java_Dislin_wgbox (JNIEnv *env, jobject object, jint ip, jstring s, jint isel)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  int id;
  id = wgbox (ip, (char *) str, isel);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return id;
}

JNIEXPORT jint JNICALL
Java_Dislin_wgbut (JNIEnv *env, jobject object, jint ip, jstring s, jint isel)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  int id;
  id = wgbut (ip, (char *) str, isel);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return id;
}

JNIEXPORT jint JNICALL
Java_Dislin_wgcmd (JNIEnv *env, jobject object, jint ip, jstring s1,
                   jstring s2)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  int id;
  id = wgcmd (ip, (char *) str1, (char *) str2);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
  return id;
}

JNIEXPORT jint JNICALL
Java_Dislin_wgfil (JNIEnv *env, jobject object, jint ip, jstring s1,
                   jstring s2, jstring s3)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  const char *str3 = (*env)->GetStringUTFChars(env, s3, 0);
  int id;
  id = wgfil (ip, (char *) str1, (char *) str2, (char *) str3);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
  (*env)->ReleaseStringUTFChars(env, s3, str3);
  return id;
}

JNIEXPORT void JNICALL
Java_Dislin_wgfin (JNIEnv *env, jobject object)
{
  wgfin ();
}

JNIEXPORT jint JNICALL
Java_Dislin_wgini (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  int id;
  id = wgini ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return id;
}

JNIEXPORT jint JNICALL
Java_Dislin_wglab (JNIEnv *env, jobject object, jint ip, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  int id;
  id = wglab (ip, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return id;
}

JNIEXPORT jint JNICALL
Java_Dislin_wglis (JNIEnv *env, jobject object, jint ip, jstring s, jint isel)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  int id;
  id = wglis (ip, (char *) str, isel);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return id;
}

JNIEXPORT jint JNICALL
Java_Dislin_wgok (JNIEnv *env, jobject object, jint i)
{ return wgok (i);
}

JNIEXPORT jint JNICALL
Java_Dislin_wgpop (JNIEnv *env, jobject object, jint ip, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  int id;
  id = wgpop (ip, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return id;
}

JNIEXPORT jint JNICALL
Java_Dislin_wgquit (JNIEnv *env, jobject object, jint i)
{ return wgquit (i);
}

JNIEXPORT jint JNICALL
Java_Dislin_wgltxt (JNIEnv *env, jobject object, jint ip, jstring s1,
                    jstring s2, jint iper)
{ const char *str1 = (*env)->GetStringUTFChars(env, s1, 0);
  const char *str2 = (*env)->GetStringUTFChars(env, s2, 0);
  int id;
  id = wgltxt (ip, (char *) str1, (char *) str2, iper);
  (*env)->ReleaseStringUTFChars(env, s1, str1);
  (*env)->ReleaseStringUTFChars(env, s2, str2);
  return id;
}

JNIEXPORT jint JNICALL
Java_Dislin_wgpbut (JNIEnv *env, jobject object, jint ip, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  int id;
  id = wgpbut (ip, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return id;
}

JNIEXPORT jint JNICALL
Java_Dislin_wgscl (JNIEnv *env, jobject object, jint ip, jstring s,
                   jfloat x1, jfloat x2, jfloat xval, jint ndez)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  int id;
  id = wgscl (ip, (char *) str, x1, x2, xval, ndez);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return id;
}

JNIEXPORT jint JNICALL
Java_Dislin_wgtxt (JNIEnv *env, jobject object, jint ip, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  int id;
  id = wgtxt (ip, (char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
  return id;
}

JNIEXPORT void JNICALL 
Java_Dislin_widbar (JNIEnv *env, jobject object, jint i)
{
  widbar (i);
}

JNIEXPORT void JNICALL
Java_Dislin_wimage (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  wimage ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_winapp (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  winapp ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_winmod (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  winmod ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL 
Java_Dislin_window (JNIEnv *env, jobject object, jint nx, jint ny, 
                                                 jint nw, jint nh)
{
  window (nx, ny, nw, nh);
}

JNIEXPORT void JNICALL
Java_Dislin_winfnt (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  winfnt ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT jint JNICALL
Java_Dislin_winid (JNIEnv *env, jobject object)
{ return winid ();
}

JNIEXPORT void JNICALL 
Java_Dislin_winsiz (JNIEnv *env, jobject object, jint i, jint j)
{
  winsiz (i, j);
}

JNIEXPORT void JNICALL
Java_Dislin_wintit (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  wintit ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_world (JNIEnv *env, jobject object)
{
  world ();
}

JNIEXPORT void JNICALL 
Java_Dislin_wpixel (JNIEnv *env, jobject object, jint i, jint j, jint k)
{
  wpixel (i, j, k);
}

JNIEXPORT void JNICALL 
Java_Dislin_wpixls (JNIEnv *env, jobject object, jbyteArray arr1, jint ix,
                    jint iy, jint nw, jint nh)
{ jbyte *cbuf = (*env)->GetByteArrayElements(env, arr1, 0);
  wpixls ((unsigned char * ) cbuf, ix, iy, nw, nh);
  (*env)->ReleaseByteArrayElements(env, arr1, cbuf, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_wpxrow (JNIEnv *env, jobject object, jbyteArray arr1, jint ix,
                    jint iy, jint n)
{ jbyte *cbuf = (*env)->GetByteArrayElements(env, arr1, 0);
  wpxrow ((unsigned char * ) cbuf, ix, iy, n);
  (*env)->ReleaseByteArrayElements(env, arr1, cbuf, 0);
}

JNIEXPORT jint JNICALL 
Java_Dislin_writfl (JNIEnv *env, jobject object, jint nu, jbyteArray arr1, 
                    jint n)
{ int iret;
  jbyte *cbuf = (*env)->GetByteArrayElements(env, arr1, 0);
  iret = writfl (nu, (unsigned char * ) cbuf, n);
  (*env)->ReleaseByteArrayElements(env, arr1, cbuf, 0);
  return iret;
}

JNIEXPORT void JNICALL
Java_Dislin_wtiff (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  wtiff ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_x11fnt (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  x11fnt ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_x11mod (JNIEnv *env, jobject object, jstring s)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  x11mod ((char *) str);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT jfloat JNICALL
Java_Dislin_x2dpos (JNIEnv *env, jobject object, jfloat x, jfloat y)
{ return x2dpos (x, y);
}

JNIEXPORT jfloat JNICALL
Java_Dislin_x3dabs (JNIEnv *env, jobject object, jfloat x, jfloat y, jfloat z)
{ return x3dabs (x, y, z);
}

JNIEXPORT jfloat JNICALL
Java_Dislin_x3dpos (JNIEnv *env, jobject object, jfloat x, jfloat y, jfloat z)
{ return x3dpos (x, y, z);
}

JNIEXPORT jfloat JNICALL
Java_Dislin_x3drel (JNIEnv *env, jobject object, jfloat x, jfloat y, jfloat z)
{ return x3drel (x, y, z);
}

JNIEXPORT void JNICALL
Java_Dislin_xaxgit (JNIEnv *env, jobject object)
{
  xaxgit ();
}

JNIEXPORT void JNICALL
Java_Dislin_xaxis (JNIEnv *env, jobject object, jfloat a, jfloat b,
                   jfloat or, jfloat step, jint nl, jstring s,
                   jint it, jint nx, jint ny)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  xaxis (a, b, or, step, nl, (char *) str, it, nx, ny);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_xaxlg (JNIEnv *env, jobject object, jfloat a, jfloat b,
                   jfloat or, jfloat step, jint nl, jstring s,
                   jint it, jint nx, jint ny)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  xaxlg (a, b, or, step, nl, (char *) str, it, nx, ny);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_xaxmap (JNIEnv *env, jobject object, jfloat a, jfloat b,
                   jfloat or, jfloat step, jstring s,
                   jint it, jint ny)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  xaxmap (a, b, or, step, (char *) str, it, ny);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_xcross (JNIEnv *env, jobject object)
{
  xcross ();
}

JNIEXPORT void JNICALL 
Java_Dislin_xdraw (JNIEnv *env, jobject object, jfloat x, jfloat y)
{
  xdraw (x, y);
}

JNIEXPORT void JNICALL 
Java_Dislin_xjdraw (JNIEnv *env, jobject object, jfloat x, jfloat y, jint i)
{
  xjdraw (x, y, i);
}

JNIEXPORT jfloat JNICALL
Java_Dislin_xinvrs (JNIEnv *env, jobject object, jint i)
{ return xinvrs (i);
}

JNIEXPORT void JNICALL 
Java_Dislin_xmove (JNIEnv *env, jobject object, jfloat x, jfloat y)
{
  xmove (x, y);
}

JNIEXPORT jfloat JNICALL
Java_Dislin_xposn (JNIEnv *env, jobject object, jfloat x)
{ return xposn (x);
}

JNIEXPORT jfloat JNICALL
Java_Dislin_y2dpos (JNIEnv *env, jobject object, jfloat x, jfloat y)
{ return y2dpos (x, y);
}

JNIEXPORT jfloat JNICALL
Java_Dislin_y3dabs (JNIEnv *env, jobject object, jfloat x, jfloat y, jfloat z)
{ return y3dabs (x, y, z);
}

JNIEXPORT jfloat JNICALL
Java_Dislin_y3dpos (JNIEnv *env, jobject object, jfloat x, jfloat y, jfloat z)
{ return x3dpos (x, y, z);
}

JNIEXPORT jfloat JNICALL
Java_Dislin_y3drel (JNIEnv *env, jobject object, jfloat x, jfloat y, jfloat z)
{ return y3drel (x, y, z);
}

JNIEXPORT void JNICALL
Java_Dislin_yaxgit (JNIEnv *env, jobject object)
{
  yaxgit ();
}

JNIEXPORT void JNICALL
Java_Dislin_yaxis (JNIEnv *env, jobject object, jfloat a, jfloat b,
                   jfloat or, jfloat step, jint nl, jstring s,
                   jint it, jint nx, jint ny)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  yaxis (a, b, or, step, nl, (char *) str, it, nx, ny);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_yaxlg (JNIEnv *env, jobject object, jfloat a, jfloat b,
                   jfloat or, jfloat step, jint nl, jstring s,
                   jint it, jint nx, jint ny)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  yaxlg (a, b, or, step, nl, (char *) str, it, nx, ny);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_yaxmap (JNIEnv *env, jobject object, jfloat a, jfloat b,
                   jfloat or, jfloat step, jstring s,
                   jint it, jint ny)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  yaxmap (a, b, or, step, (char *) str, it, ny);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_ycross (JNIEnv *env, jobject object)
{
  ycross ();
}

JNIEXPORT jfloat JNICALL
Java_Dislin_yinvrs (JNIEnv *env, jobject object, jint i)
{ return yinvrs (i);
}

JNIEXPORT jfloat JNICALL
Java_Dislin_yposn (JNIEnv *env, jobject object, jfloat x)
{ return yposn (x);
}

JNIEXPORT jfloat JNICALL
Java_Dislin_z3dpos (JNIEnv *env, jobject object, jfloat x, jfloat y, jfloat z)
{ return z3dpos (x, y, z);
}

JNIEXPORT void JNICALL
Java_Dislin_zaxis (JNIEnv *env, jobject object, jfloat a, jfloat b,
                   jfloat or, jfloat step, jint nl, jstring s,
                   jint it, jint id, jint nx, jint ny)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  zaxis (a, b, or, step, nl, (char *) str, it, id, nx, ny);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_zaxlg (JNIEnv *env, jobject object, jfloat a, jfloat b,
                   jfloat or, jfloat step, jint nl, jstring s,
                   jint it, jint id, jint nx, jint ny)
{ const char *str = (*env)->GetStringUTFChars(env, s, 0);
  zaxlg (a, b, or, step, nl, (char *) str, it, id, nx, ny);
  (*env)->ReleaseStringUTFChars(env, s, str);
}

JNIEXPORT void JNICALL
Java_Dislin_zbffin (JNIEnv *env, jobject object)
{
  zbffin ();
}

JNIEXPORT jint JNICALL
Java_Dislin_zbfini (JNIEnv *env, jobject object)
{ return zbfini ();
}

JNIEXPORT void JNICALL 
Java_Dislin_zbflin (JNIEnv *env, jobject object, jfloat x1, jfloat y1,
                    jfloat z1, jfloat x2, jfloat y2, jfloat z2)
{
  zbflin (x1, y1, z1, x2, y2, z2);
}

JNIEXPORT void JNICALL 
Java_Dislin_zbftri (JNIEnv *env, jobject object, 
        jfloatArray arr1, jfloatArray arr2, jfloatArray arr3, jintArray arr4)
{
  jfloat *xray = (*env)->GetFloatArrayElements(env, arr1, 0);
  jfloat *yray = (*env)->GetFloatArrayElements(env, arr2, 0);
  jfloat *zray = (*env)->GetFloatArrayElements(env, arr3, 0);
  jint   *iray = (*env)->GetIntArrayElements(env, arr4, 0);
  zbftri ((float *) xray, (float *) yray, (float *) zray, (int *) iray);
  (*env)->ReleaseFloatArrayElements(env, arr1, xray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr2, yray, 0);
  (*env)->ReleaseFloatArrayElements(env, arr3, zray, 0);
  (*env)->ReleaseIntArrayElements(env, arr4, iray, 0);
}

JNIEXPORT void JNICALL 
Java_Dislin_zscale (JNIEnv *env, jobject object, jfloat x, jfloat y)
{
  zscale (x, y);
}










